# coding: utf-8

"""
    Form Service API

    A list of form and Xaas APIs.  This page describes the RESTful APIs for Form Service. The APIs facilitate CRUD operations on the various resources and entities used throughout Form service (Custom Resource , Form Definition etc.) and allow operations on them (creating custom resource type , fetch form status etc.).  Some of the APIs that list collections of resources also support OData like implementation. Below query params can be used across Form and XaaS entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/form-service/api/custom/resource-types?$orderby=name%20DESC```  2. `page`, `size` - page used in conjunction with `size` helps in pagination of resources.      ```/form-service/api/custom/resource-types?page=0&size=20```   # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class FormsVersionsBody(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'source_type': 'str',
        'source_id': 'str',
        'form_type': 'str',
        'name': 'str',
        'description': 'str',
        'change_log': 'str'
    }

    attribute_map = {
        'source_type': 'sourceType',
        'source_id': 'sourceId',
        'form_type': 'formType',
        'name': 'name',
        'description': 'description',
        'change_log': 'changeLog'
    }

    def __init__(self, source_type=None, source_id=None, form_type=None, name=None, description=None, change_log=None):  # noqa: E501
        """FormsVersionsBody - a model defined in Swagger"""  # noqa: E501
        self._source_type = None
        self._source_id = None
        self._form_type = None
        self._name = None
        self._description = None
        self._change_log = None
        self.discriminator = None
        if source_type is not None:
            self.source_type = source_type
        if source_id is not None:
            self.source_id = source_id
        if form_type is not None:
            self.form_type = form_type
        if name is not None:
            self.name = name
        if description is not None:
            self.description = description
        if change_log is not None:
            self.change_log = change_log

    @property
    def source_type(self):
        """Gets the source_type of this FormsVersionsBody.  # noqa: E501


        :return: The source_type of this FormsVersionsBody.  # noqa: E501
        :rtype: str
        """
        return self._source_type

    @source_type.setter
    def source_type(self, source_type):
        """Sets the source_type of this FormsVersionsBody.


        :param source_type: The source_type of this FormsVersionsBody.  # noqa: E501
        :type: str
        """

        self._source_type = source_type

    @property
    def source_id(self):
        """Gets the source_id of this FormsVersionsBody.  # noqa: E501


        :return: The source_id of this FormsVersionsBody.  # noqa: E501
        :rtype: str
        """
        return self._source_id

    @source_id.setter
    def source_id(self, source_id):
        """Sets the source_id of this FormsVersionsBody.


        :param source_id: The source_id of this FormsVersionsBody.  # noqa: E501
        :type: str
        """

        self._source_id = source_id

    @property
    def form_type(self):
        """Gets the form_type of this FormsVersionsBody.  # noqa: E501


        :return: The form_type of this FormsVersionsBody.  # noqa: E501
        :rtype: str
        """
        return self._form_type

    @form_type.setter
    def form_type(self, form_type):
        """Sets the form_type of this FormsVersionsBody.


        :param form_type: The form_type of this FormsVersionsBody.  # noqa: E501
        :type: str
        """

        self._form_type = form_type

    @property
    def name(self):
        """Gets the name of this FormsVersionsBody.  # noqa: E501


        :return: The name of this FormsVersionsBody.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this FormsVersionsBody.


        :param name: The name of this FormsVersionsBody.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def description(self):
        """Gets the description of this FormsVersionsBody.  # noqa: E501


        :return: The description of this FormsVersionsBody.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this FormsVersionsBody.


        :param description: The description of this FormsVersionsBody.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def change_log(self):
        """Gets the change_log of this FormsVersionsBody.  # noqa: E501


        :return: The change_log of this FormsVersionsBody.  # noqa: E501
        :rtype: str
        """
        return self._change_log

    @change_log.setter
    def change_log(self, change_log):
        """Sets the change_log of this FormsVersionsBody.


        :param change_log: The change_log of this FormsVersionsBody.  # noqa: E501
        :type: str
        """

        self._change_log = change_log

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(FormsVersionsBody, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FormsVersionsBody):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
